﻿using ProjectDumpTruck.Drawnings;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ProjectDumpTruck.Exceptions;

namespace ProjectDumpTruck.CollectionGenericObject;

public class Autopark : AbstractCompany
{
    public Autopark(int picWidth, int picHeight, ICollectionGenericObject<DrawningTruck> collection) : base(picWidth, picHeight, collection)
    {
    }

    protected override void DrawBackground(Graphics g)
    {
        Pen pen = new(Color.Black, 2);
        Pen Pen2 = new(Color.Black, 3);

        for (int i = 0; i < _pictureHeight / _placeSizeHeight; i++)
        {
            int y = _placeSizeHeight;
            y *= i;

            for (int j = 0; j <= _pictureWidth / _placeSizeWidth; j++)
            {
                int x = _placeSizeWidth;
                x *= j;

                g.DrawLine(Pen2, x+10, y, x + _placeSizeWidth / 2, y);
                g.DrawLine(Pen2, x+10, y + _placeSizeHeight - 10, x + _placeSizeWidth / 2, y + _placeSizeHeight - 10);
                g.DrawLine(pen, x + 10, y, x+10, y + _placeSizeHeight - 10);
            }
        }
    }

    protected override void SetObjectsPosition()
    {
        int n = 0;
        int m = 0;

        for (int i = 0; i < (_collection?.Count ?? 0); i++)
        {
            try 
            {
                if (_collection?.Get(i) != null)
                {
                    int x = 20 + _placeSizeWidth * n;
                    int y = 10 + _placeSizeHeight * m;

                    _collection?.Get(i)?.SetPictureSize(_pictureWidth, _pictureHeight);
                    _collection?.Get(i)?.SetPosition(x, y);
                }

                if (n < _pictureWidth / _placeSizeWidth) n++;

                else
                {
                    n = 0;
                    m++;
                }
            }
            catch (ObjectNotFoundException)
            {
                break;
            }
        }
    }
}
